com.comtrade.ecm.engine.business.entity.attributes

## Class EcmAttributeDefinition

- java.lang.Object
- - com.comtrade.ecm.engine.business.entity.attributes.EcmAttributeDefinition

- All Implemented Interfaces:
    AttributeDefinition, Nameable, java.io.Serializable

      public class EcmAttributeDefinition
      extends java.lang.Object
      implements AttributeDefinition, java.io.Serializable

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `EcmAttributeDefinition.AmountBuilder`
    `static class` | `EcmAttributeDefinition.BooleanBuilder`
    `static class` | `EcmAttributeDefinition.BusinessIdBuilder`
    `static class` | `EcmAttributeDefinition.BusinessKeyBuilder`
    `static class` | `EcmAttributeDefinition.ByteArrayBuilder`
    `static class` | `EcmAttributeDefinition.DateBuilder`
    `static class` | `EcmAttributeDefinition.DateTimeBuilder`
    `static class` | `EcmAttributeDefinition.DoubleBuilder`
    `static class` | `EcmAttributeDefinition.EcmStreamBuilder`
    `static class` | `EcmAttributeDefinition.FloatBuilder`
    `static class` | `EcmAttributeDefinition.ForeignKeyBuilder`
    `static class` | `EcmAttributeDefinition.IdBuilder`
    `static class` | `EcmAttributeDefinition.IntBuilder`
    `static class` | `EcmAttributeDefinition.LongBuilder`
    `static class` | `EcmAttributeDefinition.ObjectBuilder`
    `static class` | `EcmAttributeDefinition.PredefinedBuilder`
    `static class` | `EcmAttributeDefinition.StringBuilder`
    `static class` | `EcmAttributeDefinition.TextBuilder`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Class<?>` | `getClazz()`
    `int` | `getMaxLength()`
    `int` | `getMaxTableLength()`
    `int` | `getMinLength()`
    `java.lang.String` | `getName()` Returns "a name" of an object.
    `java.lang.String` | `getNameId()`
    `AttributeShowability` | `getRecordShowable()`
    `static long` | `getSerialversionuid()`
    `AttributeShowability` | `getShowable()`
    `java.lang.String` | `getTableName()`
    `AttributeShowability` | `getTableShowable()`
    `java.lang.String` | `getTitle()`
    `java.lang.String` | `getType()`
    `boolean` | `isEditable()`
    `boolean` | `isExportable()`
    `boolean` | `isFilterable()`
    `boolean` | `isNative()`
    `boolean` | `isNullable()`
    `boolean` | `isRecordEditable()`
    `boolean` | `isRecordShowable()`
    `boolean` | `isRepeating()`
    `boolean` | `isShowable()`
    `boolean` | `isSummable()`
    `boolean` | `isTableEditable()`
    `boolean` | `isTableShowable()`
    `boolean` | `isTrimmed()`
    `boolean` | `isValueHidden()`
    `void` | `setClazz(java.lang.Class<?> clazz)`
    `void` | `setEditable(boolean editable)`
    `void` | `setExportable(boolean exportable)`
    `void` | `setFilterable(boolean filterable)`
    `void` | `setMaxLength(int maxLength)`
    `void` | `setMaxTableLength(int maxTableLength)`
    `void` | `setMinLength(int minLength)`
    `void` | `setName(java.lang.String name)`
    `void` | `setNative(boolean nativeColumn)`
    `void` | `setNullable(boolean nullable)`
    `void` | `setRecordEditable(boolean recordEditable)`
    `void` | `setRecordShowable(AttributeShowability recordShowable)`
    `void` | `setShowable(AttributeShowability showable)`
    `void` | `setSummable(boolean summable)`
    `void` | `setTableEditable(boolean tableEditable)`
    `void` | `setTableName(java.lang.String tableName)`
    `void` | `setTableShowable(AttributeShowability tableShowable)`
    `void` | `setTitle(java.lang.String title)`
    `void` | `setTrimmed(boolean trimmed)`
    `void` | `setType(java.lang.String type)`
    `void` | `setValueHidden(boolean valueHidden)`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### getName

          public java.lang.String getName()

      Description copied from interface: `Nameable`
      Returns "a name" of an object.
      Specified by:
        `getName` in interface `AttributeDefinition`
      Specified by:
        `getName` in interface `Nameable`
      Returns:
        Name of a attribute

    - #### getTableName

          public java.lang.String getTableName()

      Specified by:
        `getTableName` in interface `AttributeDefinition`
      Returns:
        Name of a source (persistence level) column

    - #### getNameId

          public java.lang.String getNameId()

    - #### getTitle

          public java.lang.String getTitle()

      Specified by:
        `getTitle` in interface `AttributeDefinition`
      Returns:
        Language-properties key of a title attribute

    - #### getType

          public java.lang.String getType()

      Specified by:
        `getType` in interface `AttributeDefinition`
      Returns:
        Type of a attribute

    - #### isNative

          public boolean isNative()

      Specified by:
        `isNative` in interface `AttributeDefinition`
      Returns:
        Does this column belong to an entity, or is an additional data from a related entity

    - #### isNullable

          public boolean isNullable()

      Specified by:
        `isNullable` in interface `AttributeDefinition`
      Returns:
        Can this attribute have NULL content

    - #### getShowable

          public AttributeShowability getShowable()

      Specified by:
        `getShowable` in interface `AttributeDefinition`
      Returns:
        Can this attribute be shown (at all)

    - #### getTableShowable

          public AttributeShowability getTableShowable()

      Specified by:
        `getTableShowable` in interface `AttributeDefinition`
      Returns:
        Can this attribute be shown in a datagrid

    - #### getRecordShowable

          public AttributeShowability getRecordShowable()

      Specified by:
        `getRecordShowable` in interface `AttributeDefinition`
      Returns:
        Can this attribute be shown in a record form

    - #### isShowable

          public boolean isShowable()

      Specified by:
        `isShowable` in interface `AttributeDefinition`
      Returns:
        Is this attribute showable (at all, in datagrid, in record form)

    - #### isTableShowable

          public boolean isTableShowable()

      Specified by:
        `isTableShowable` in interface `AttributeDefinition`

    - #### isRecordShowable

          public boolean isRecordShowable()

      Specified by:
        `isRecordShowable` in interface `AttributeDefinition`

    - #### isEditable

          public boolean isEditable()

      Specified by:
        `isEditable` in interface `AttributeDefinition`
      Returns:
        Is attribute editable (at all)

    - #### isTableEditable

          public boolean isTableEditable()

      Specified by:
        `isTableEditable` in interface `AttributeDefinition`
      Returns:
        Is attribute editable in a datagrid

    - #### isRecordEditable

          public boolean isRecordEditable()

      Specified by:
        `isRecordEditable` in interface `AttributeDefinition`
      Returns:
        Is column attribute in a record form

    - #### isSummable

          public boolean isSummable()

      Specified by:
        `isSummable` in interface `AttributeDefinition`
      Returns:
        Should this attribute have a sum?

    - #### isTrimmed

          public boolean isTrimmed()

      Specified by:
        `isTrimmed` in interface `AttributeDefinition`
      Returns:
        Should a value of this attribute be trimmed?

    - #### isRepeating

          public boolean isRepeating()

      Specified by:
        `isRepeating` in interface `AttributeDefinition`
      Returns:
        Does attribute represent a collection of data (of the same type)

    - #### setTrimmed

          public void setTrimmed(boolean trimmed)

    - #### isValueHidden

          public boolean isValueHidden()

      Specified by:
        `isValueHidden` in interface `AttributeDefinition`
      Returns:
        Should a value of this attribute be shown with secret/hidden characters (for example, a password)?

    - #### setValueHidden

          public void setValueHidden(boolean valueHidden)

    - #### isExportable

          public boolean isExportable()

      Specified by:
        `isExportable` in interface `AttributeDefinition`
      Returns:
        Is attribute exportable

    - #### setExportable

          public void setExportable(boolean exportable)

      Specified by:
        `setExportable` in interface `AttributeDefinition`

    - #### setShowable

          public void setShowable(AttributeShowability showable)

      Specified by:
        `setShowable` in interface `AttributeDefinition`

    - #### setTableShowable

          public void setTableShowable(AttributeShowability tableShowable)

      Specified by:
        `setTableShowable` in interface `AttributeDefinition`

    - #### setRecordShowable

          public void setRecordShowable(AttributeShowability recordShowable)

      Specified by:
        `setRecordShowable` in interface `AttributeDefinition`

    - #### setEditable

          public void setEditable(boolean editable)

      Specified by:
        `setEditable` in interface `AttributeDefinition`

    - #### setTableEditable

          public void setTableEditable(boolean tableEditable)

      Specified by:
        `setTableEditable` in interface `AttributeDefinition`

    - #### setRecordEditable

          public void setRecordEditable(boolean recordEditable)

      Specified by:
        `setRecordEditable` in interface `AttributeDefinition`

    - #### setSummable

          public void setSummable(boolean summable)

      Specified by:
        `setSummable` in interface `AttributeDefinition`

    - #### setNullable

          public void setNullable(boolean nullable)

      Specified by:
        `setNullable` in interface `AttributeDefinition`

    - #### isFilterable

          public boolean isFilterable()

      Specified by:
        `isFilterable` in interface `AttributeDefinition`

    - #### setFilterable

          public void setFilterable(boolean filterable)

      Specified by:
        `setFilterable` in interface `AttributeDefinition`

    - #### setNative

          public void setNative(boolean nativeColumn)

    - #### getMinLength

          public int getMinLength()

      Specified by:
        `getMinLength` in interface `AttributeDefinition`

    - #### setMinLength

          public void setMinLength(int minLength)

    - #### getMaxLength

          public int getMaxLength()

      Specified by:
        `getMaxLength` in interface `AttributeDefinition`

    - #### setMaxLength

          public void setMaxLength(int maxLength)

    - #### getMaxTableLength

          public int getMaxTableLength()

      Specified by:
        `getMaxTableLength` in interface `AttributeDefinition`

    - #### setMaxTableLength

          public void setMaxTableLength(int maxTableLength)

    - #### getSerialversionuid

          public static long getSerialversionuid()

    - #### setName

          public void setName(java.lang.String name)

    - #### setTableName

          public void setTableName(java.lang.String tableName)

    - #### setTitle

          public void setTitle(java.lang.String title)

    - #### setType

          public void setType(java.lang.String type)

    - #### setClazz

          public void setClazz(java.lang.Class<?> clazz)

    - #### getClazz

          public java.lang.Class<?> getClazz()

      Specified by:
        `getClazz` in interface `AttributeDefinition`
      Returns:
        Type of a attribute as Class object

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`